/*
	kkcsel.c

	by t.ebisawa
*/

#include <stdio.h>
#include <stdlib.h>
#include <dos.h>

typedef union KKCSTAT {
	struct {
		short int	flag;
		char far *	name;
	} kkc;
	struct {
		short int	maxnum;
		short int	curnum;
		short int	selected;
	} info;
} KKCSTAT, far * LPKKCSTAT;

const char	msgOpening[] = "KKCSEL : Japanese Kana-Kanji Conveter select\n" \
                           "         (c)sava/LP-Project. 1997\n" ;
const char	msgNoKKCFunc[] = "LPKKC.SYS  KKCFUNC.SYS CXg[Ă܂";
const char	msgKKCnone[] = "ȊϊCXg[Ă܂";
const char	msgFreeField[] = "@@iȂj";
const char	msgMaxKKC[] = "Ȋϊ %d o^\ł\n";
const char	msgCurKKC[] = "݁A%d ̂Ȋϊo^Ă܂\n";
const char	msgChoiceKKC[] = "Ił";
const char	msgOutOf[] = "͈͊Oł";
const char	msgSuccess[] = "؂肩ɐAƎv܂";
const char	msgFailure[] = "؂肩Ɏs悤ł";

void
far_puts(char far *s)
{
	char	c;
	
	while('\0' != (c = *s++))	putchar(c);
}

void
disp_kkcs(LPKKCSTAT ks)
{
	int		i, dk;
	
	dk = 0;
	for(i = 1; i <= ks->info.maxnum; i++) {
		if (dk >= ks->info.curnum)	break;
		printf("%c %2d  ", (i == ks->info.selected) ? '*' : ' ', i);
		if (0 != ks[i].kkc.flag) {
			far_puts(ks[i].kkc.name);
			putchar('\n');
			dk++;
		}
		else {
			puts(msgFreeField);
		}
	}
	
	putchar('\n');
	printf(msgMaxKKC, ks->info.maxnum);
	printf(msgCurKKC, ks->info.curnum);
	putchar('\n');
}

int
getdigit()
{
	int		result = -1;
	union REGS	r;
	int			pos;
	char		s[4];
	
	s[0] = s[1] = s[2] = s[3] = '\0';
	pos = 0;
	
	for(;;) {
		r.h.ah = 8;
		intdos(&r, &r);
		if (13 == r.h.al) {
			result = atoi(s);
			break;
		} else if (0x1b == r.h.al) {
			break;
		} else if (8 == r.h.al) {
			if (0 < pos) {
				putchar(8); putchar(' '); putchar(8);
				pos--;
			} else if (0 == pos) { putchar(' '); putchar(8); }
			s[pos] = ' ';
		} else if ('0' <= r.h.al && '9' >= r.h.al) {
			if (pos <= 1) { putchar(s[pos] = r.h.al); pos++; }
		}
	}
	putchar('\n');
	
	return result;
}

int
main(int argc, char **argv)
{
	union REGS		r;
	struct SREGS	sr;
	LPKKCSTAT		ks;
	int				choice;
	
	puts(msgOpening);
	
	r.x.ax = 0x4d03;
	int86x(0x2f,&r,&r,&sr);
	if (0 != r.x.ax) {
		puts(msgNoKKCFunc);
		return 1;
	}
	ks = (LPKKCSTAT)MK_FP(sr.es, r.x.di);
	
	disp_kkcs(ks);
	if (1 < ks->info.curnum) {
		printf("%s : ", msgChoiceKKC);
		choice = getdigit();
		if (0 >= choice) return 0; /* canceled */
		if (choice > ks->info.maxnum || 0 == ks[choice].kkc.flag) {
			puts(msgOutOf);
			return 1;
		}
		r.x.ax = 0x4d04;
		r.x.bx = choice;
		int86(0x2f,&r,&r);
		if (0 != r.x.ax) {
			puts(msgFailure);
			return 1;
		}
		puts(msgSuccess);
	}
	return 0;
}
