COMMENT #
===============================================================================
    LPKKC : KKCFUNC.SYS clone -- Japanese Kana-Kanji Converter supporter

    lpkkc.asm
    by t.ebisawa (lpproj@gmail.com)

    To build, use MASM 4.0+, TASM or ArrowASM

    lpkkcwin.sys (MASM 5.x)
        masm /ml /DUSE_WINDOWS lpkkc,lpkkcwin;
        link /NOI lpkkcwin;
        exe2bin lpkkcwin.exe lpkkcwin.sys

    lpkkcmin.sys (MASM 5.x)
        masm /ml /DBUILD_MINIMUM lpkkc,lpkkcmin;
        link /NOI lpkkcmin;
        exe2bin lpkkcmin.exe lpkkcmin.sys

    Or you can build them with OpenWatcom.
        wmake -f Makefile.wc


2009-04-25	v1.05
	fix save/restore SDA length in Wrap21. Thanks to reiria.
	fix some variables ambiguity (mostly for Watcom Assembler)
	Makefile.wc for OpenWatcom

2004-11-23	v1.04
	branch: lpkkc/lpkkcwin/lpkkcmin
	support int 2fh ax=4b05h
	 (for DOS-based Task Switcher: DOSSHELL, TaskMax...)
	move locaion of init code

2002-11-30	v1.03
	reverve SDA more larger (for FreeDOS ke2072)

2002-02-27	v1.02
	prepare "int 2Fh, ah=4Eh" stub
	shrink size of private stack (just a bit...)

1997-12-01	v1.01
	Commands fixed
	int 2fh, ax=1605h fixed

1997-11-21	v1.00
	initial

===============================================================================
#

					; Edit here if you use MASM3.0
					;
;BUILD_MINIMUM	EQU	1		; <- to build lpkkcmin.sys
;USE_WINDOWS	EQU	1		; <- to build lpkkc*.sys using with 
					;    windows 3.x/95/98?

MAJOR		EQU	1		; LPKKC Internal version
MINOR		EQU	05h		; 

MAX_NUM_KKC	EQU	4		; 16 as original KKCFUNC

WRAP21_NOERROR	EQU	0
WRAP21_INJOB	EQU	2		; wrap21 in job
WRAP21_ERROR	EQU	3		; error was occured in wrap21
WRAP21_STACK	EQU	256		; (I don't know how many size.)
WRAP21_STACKMAX	EQU	512
WARP21_STACKMIN	EQU	64

MAX_PRIVATE_SDA	EQU	4096

KKCstat		STRUC
ks_flag		dw	?
ks_name		dd	?
KKCstat		ENDS

CR		EQU	13
LF		EQU	10
HT		EQU	9

sinfo		STRUC
si_Major	db	3	; 3
si_Minor	db	0	; 0
si_next		dd	?	; ptr to prev sinfo
si_vxdname	dd	0	; ptr to vxd name
si_vxdref	dd	0	; vxd refrence info
si_sinst	dd	?	; ptr to sinst
sinfo		ENDS

sinst		STRUC
sinst_ptr	dd	?	; top of instance data
sinst_size	dw	?	; size of instance data
sinst		ENDS



movseg		MACRO	p1,p2
	push	p2
	pop	p1
ENDM

pushm		MACRO	p1
	IRP	p2,<p1>
		push	p2
	ENDM
ENDM

popm		MACRO	p1
	IRP	p2,<p1>
		pop	p2
	ENDM
ENDM

jmps		MACRO	p1
	jmp	short p1
ENDM

ofs		EQU	offset

_TEXT	SEGMENT PARA PUBLIC 'CODE'
_TEXT	ENDS

		ASSUME cs:_TEXT, ds:_TEXT

_TEXT		SEGMENT
	ORG	0

		dd	-1
		dw	8000h
		dw	ofs Strategy
Dev_commands	dw	ofs Init_Commands
Dev_Name	db	'KKCFUNC$'
Dev_ID		db	'LPKK'
		IFDEF	BUILD_MINIMUM
		db	'm'
		ELSE
		 IFDEF	USE_WINDOWS
		 db	'w'
		 ELSE
		 db	'C'
		 ENDIF
		ENDIF
		db	'0'+MAJOR,'0'+(MINOR SHR 4),'0'+(MINOR AND 15)

Org2F		dd	?

		IFNDEF	BUILD_MINIMUM

private_dta	LABEL	DWORD		; private_psp:0080h
		dw	0080h
private_psp	dw	?

private_stack	dd	?

indos		dd	?
sda_top		dd	?
sda_size	dw	?		; count by word, not by byte
sda_indos	dw	?		; count by word, not by byte

		ENDIF			; ifndef BUILD_MINIMUM


		IFDEF	USE_WINDOWS

StartInfo	sinfo <>
inst_kkc	sinst <>
		sinst <0,0>

		ENDIF			; ifdef USE_WINDOWS

New2F		PROC	FAR
	cmp	ah,4dh
	je	new2f_4dxx
	
		IFDEF	USE_WINDOWS
	cmp	ax,4b05h		; int 2Fh, ax=4B05h
	je	new2f_inst		; DOSSHELL (Task Switcer) instance
	cmp	ax,1605h
	jne	new2f_org
	test	dl,00000001b
	jnz	new2f_org
					; int 2Fh, ax=1605, (dx & 1) == 0
					; Windows (Enh) startup broadcast...
new2f_inst:
	pushf
	call	cs:[Org2F]
	mov	word ptr cs:[StartInfo.si_next],bx
	mov	word ptr cs:[StartInfo.si_next + 2],es
	movseg	es,cs
	mov	bx,ofs StartInfo
	iret
		ENDIF			; ifdef USE_WINDOWS
	cmp	ah,4eh
	je	new2f_4e
new2f_org:
	jmp	cs:[Org2F]
;
new2f_4e:
	; int 2fh, ah=4eh
	; (stub for kkc server?)
	cmp	al,53h		; 2F4E53 ... SilverNet (see Interrupt List)
	je	new2f_org
	cmp	word ptr cs:[num_kkc],0
	je	new2f_4e_iret
	mov	ax,-1
new2f_4e_iret:
	iret
;
new2f_4dxx:
	cmp	al,0
	je	Func4D00
	cmp	al,1
	je	Func4D01
	cmp	al,3
	je	Func4D03
	cmp	al,4
	je	Func4D04
	cmp	al,2
	je	Func4D02
	jmps	new2f_org
New2F		ENDP


COMMENT #
---------------------------------------
  int 2fh, ax=4d00h
  Query "int21 wrapper" entry address
  (for KKC?)

  [result]
  cx:dx     entry segment:offset
  ax         0
---------------------------------------
#
Func4D00	PROC	FAR
	mov	cx,cs
	mov	dx,ofs Wrap21
	xor	ax,ax
	iret
Func4D00	ENDP


COMMENT #
---------------------------------------
  int 2fh, ax=4d03h
  Query KKCs registry
  
  [result]
  bx        index value of active KKC
  cx        current number of KKCs
  es:di     pointer to KKCs registry
  ax        0
---------------------------------------
#
Func4D03	PROC	FAR
	mov	cx,cs:[num_kkc]
	mov	bx,cs:[cur_kkc]
	movseg	es,cs
	mov	di,ofs KKCreg
	xor	ax,ax
	iret
Func4D03	ENDP


COMMENT #
---------------------------------------
  int 2fh, ax=4d04h
  Activate KKC

  [caller]
  bx        index value of KKC

  [result]
  ax        status
             0     ... success
             ffffh ... failure
---------------------------------------
#
Func4D04	PROC	FAR
	pushm	<dx,di,ds>
	movseg	ds,cs
	lea	ax,[bx-1]
	cmp	ax,[num_kkc]
	jae	func4d04_fail
	mov	di,ofs KKCreg + 6
	add	ax,ax
	add	di,ax
	add	ax,ax
	add	di,ax
	cmp	word ptr [di + (KKCstat.ks_flag)],0
	je	func4d04_fail
	mov	ax,[cur_kkc]
	cmp	ax,-1
	je	func4d04_act
	cmp	ax,bx
	je	func4d04_ok
	push	bx
	mov	bx,ax
	mov	ax,4e05h
	mov	dl,0
	int	2fh			; int 2Fh, ax=4E05h, dl=0
					; (internal) inactivate KKC?
					; (Maybe, this function is supported
					;  by KKCs.)
	pop	bx
func4d04_act:
	mov	ax,4e05h
	mov	dl,1
	int	2fh			; int 2Fh, ax=4E05h, dl=1
					; (internal) activate KKC?
					; (Maybe, this function is supported
					;  by KKCs.)
	mov	[cur_kkc],bx
func4d04_ok:
	xor	ax,ax
func4d04_ret:
	popm	<ds,di,dx>
	iret
func4d04_fail:
	mov	ax,-1
	jmps	func4d04_ret
Func4D04	ENDP



COMMENT #
---------------------------------------
  int 2fh, ax=4d01h
  Query "int21 wrapper" status

  [result]
  ax        status
             0 ... no error, not busy
             1 ... working now
             3 ... critical error occur
  dx        critical error code
            (only if ax==3)
---------------------------------------
#
Func4D01	PROC	FAR
	mov	ax,cs:[wrap_status]
	cmp	ax,WRAP21_ERROR
	jne	func4d01_ret
	mov	dx,cs:[wrap_errorcode]
func4d01_ret:
	iret
Func4D01	ENDP


COMMENT #
---------------------------------------
  int 2fh, ax=4d02h, cl=0/1
  Add/remove KKC

  cl = 0 ... Add KKC
  
  [caller]
  dx        KKC flag (set by KKC)
  ds:si     pointer to KKC's name
            (set by KKC)
  [result]
  ax        status
             0     ... success
             ffffh ... failure
  bx        index value of KKC

  cl = 1 ... Remove KKC
  
  [caller]
  bx        index value of KKC

  [result]
  ax        status
             0     ... success
             ffffh ... failure

---------------------------------------
#
Func4D02	PROC	FAR
	pushm	<dx,si,di,ds,es>
	movseg	es,ds			; es:si ... KKC name
	movseg	ds,cs
	cmp	cl,0
	je	_addkkc
	cmp	cl,1
	je	_rmkkc
func4d02_fail:
	mov	ax,-1
	jmp	func4d02_ret
;
_addkkc:
	call	KKCFindSpc
	jne	func4d02_fail
	mov	bx,ax
_addkkc_attatch:
	mov	[di + (KKCstat.ks_flag)],dx
	mov	word ptr [di + (KKCstat.ks_name)],si
	mov	word ptr [di + (KKCstat.ks_name) + 2],es
	; ****
	; inactivate old KKC...
	; ****
	mov	ax,[cur_kkc]
	cmp	ax,-1
	je	_addkkc_act
	push	bx
	mov	bx,ax
	mov	ax,4e05h
	xor	dl,dl
	int	2fh			; int 2Fh, ax=4E05h, dl=0
					; (internal) inactivate KKC?
					; (Maybe, this function is supported
					;  by KKCs.)
	pop	bx
_addkkc_act:
	mov	[cur_kkc],bx
	inc	word ptr [num_kkc]
	xor	ax,ax
	jmps	func4d02_ret
;
; remove KKC
;
_rmkkc:
	lea	ax,[bx-1]
	cmp	ax,[max_kkc]
	jae	func4d02_fail
	mov	di,ofs KKCreg + 6
	add	ax,ax
	add	di,ax
	add	ax,ax
	add	di,ax
	xor	ax,ax
	mov	[di + (KKCstat.ks_flag)],ax
	mov	word ptr [di + (KKCstat.ks_name)],ax
	mov	word ptr [di + (KKCstat.ks_name) + 2],ax
	
	cmp	bx,[cur_kkc]
	jne	_rmkkc_ok
	mov	ax,4e05h
	xor	dl,dl
	int	2fh			; int 2Fh, ax=4E05h, dl=0
					; (internal) inactivate KKC?
					; (Maybe, this function is supported
					;  by KKCs.)
	; ****
	; activate other KKC
	; ****
	mov	word ptr [cur_kkc],-1
	call	KKCFindSpc
	jne	func4d02_fail
	cmp	ax,1
	jbe	_rmkkc_ok
	dec	ax
	push	bx
	mov	bx,ax
	mov	ax,4e05h
	mov	dl,1
	int	2fh			; int 2Fh, ax=4E05h, dl=1
					; (internal) activate KKC?
					; (Maybe, this function is supported
					;  by KKCs.)
	mov	[cur_kkc],bx
	pop	bx
_rmkkc_ok:
	dec	word ptr [num_kkc]
	xor	ax,ax
func4d02_ret:
	popm	<es,ds,di,si,dx>
	iret
Func4D02	ENDP

KKCFindSpc	PROC	NEAR
	mov	ax,1
	mov	di,ofs KKCreg + 6
kkcfindspc_lp:
	cmp	word ptr [di + (KKCstat.ks_flag)],0
	je	kkcfindspc_exit
	inc	ax
	add	di, SIZE KKCstat
	cmp	ax,[max_kkc]
	jbe	kkcfindspc_lp
kkcfindspc_exit:
	ret		; if spc found ... zero-flag will be set, ax set index
			; else ... zero-flag will not
KKCFindSpc	ENDP



COMMENT #
---------------------------------------
  Int 21h Wrapper (maybe for KKC)

  process flow:
  
  * check if critlcal error has occured
  * check wrapper's injob flag
  * set wrapper's injob flag
  * prepare private stack
  * save SDA
  * set BREAK off
  * assign PSP to LPKKC's private one
  * assign DTA to LPKKC's private one
  * prepare private int23h(Ctrl-C)/24h(Critical) handler
  * invoke int 21h
  * remove int23h/24h handler
  * restore DTA
  * restore PSP
  * restore BREAK state
  * restore SDA
  * dispose private stack
  * clear wrapper's injob flag

---------------------------------------
#

		IFDEF	BUILD_MINIMUM

Wrap21		PROC	FAR
	int	21h			; warranty void if you use this;p
	ret
Wrap21		ENDP

		ELSE

Wrap21		PROC	FAR
	mov	word ptr cs:[wrap_status],WRAP21_NOERROR	; clear status 
	mov	word ptr cs:[wrap_errorcode],0
	cli
	pushm	<bx,ds>
	lds	bx,cs:[sda_top]			; sda_top as critical-err flag
	cmp	byte ptr [bx],0
	popm	<ds,bx>
	je	wrap21_2
	mov	ax,WRAP21_INJOB			; wrap21 is working
	jmp	wrap21_err
wrap21_2:
	cmp	byte ptr cs:[wrap_injob],0
	je	wrap21_3
	mov	ax,WRAP21_INJOB			; wrap21 is working
	jmp	wrap21_err
wrap21_3:
	mov	byte ptr cs:[wrap_injob],1
	cld
						; prepare private stack
	mov	word ptr cs:[wrap_prevstack],sp
	mov	word ptr cs:[wrap_prevstack+2],ss
	mov	sp,word ptr cs:[private_stack]
	mov	ss,word ptr cs:[private_stack+2]
	
	pushm	<ax,bx,cx,dx,si,di,ds,es>
						; save sda
	lds	si,cs:[indos]
	mov	cx,cs:[sda_indos]
	cmp	byte ptr [si],0
	jne	wrap21_restoresda
	mov	cx,cs:[sda_size]
wrap21_restoresda:
	mov	cs:[wrap_sdasize],cx
	lds	si,cs:[sda_top]
	movseg	es,cs
	mov	di,ofs private_sda
	rep	movsw
						; break off
	mov	ax,3300h
	int	21h
	mov	cs:[wrap_prevbreak],dl
	xor	dl,dl
	mov	ax,3301h
	int	21h
						; assign psp & dta
	mov	ah,62h
	int	21h
	mov	cs:[wrap_prevpsp],bx
	mov	ah,2fh
	int	21h
	mov	word ptr cs:[wrap_prevdta],bx
	mov	word ptr cs:[wrap_prevdta+2],es
	
	mov	ah,50h
	mov	bx,cs:[private_psp]
	int	21h
	mov	ah,1ah
	lds	dx,cs:[private_dta]
	int	21h
						; switch int23/24
	cli
	xor	ax,ax
	mov	es,ax
	movseg	ds,cs
	mov	di, 0023h * 4
	mov	ax,es:[di]
	mov	word ptr [wrap_prev23],ax
	mov	ax,es:[di + 2]
	mov	word ptr [wrap_prev23 + 2],ax
	mov	ax,es:[di + 4]
	mov	word ptr [wrap_prev24],ax
	mov	ax,es:[di + 6]
	mov	word ptr [wrap_prev24 + 2],ax
	mov	ax,ofs PrivateInt23h
	stosw
	mov	ax,cs
	stosw
	mov	ax,ofs PrivateInt24h
	stosw
	mov	ax,cs
	stosw
	popm	<es,ds,di,si,dx,cx,bx,ax>
						; int21h 
	int	21h
	
	pushf
	cli
	pushm	<ax,bx,cx,dx,si,di,ds,es>
						; remove int23/24
	xor	ax,ax
	mov	es,ax
	mov	di,0023h * 4
	mov	ax,word ptr cs:[wrap_prev23]
	stosw
	mov	ax,word ptr cs:[wrap_prev23 + 2]
	stosw
	mov	ax,word ptr cs:[wrap_prev24]
	stosw
	mov	ax,word ptr cs:[wrap_prev24 + 2]
	stosw
						; remove dta & psp
	lds	dx,cs:[wrap_prevdta]
	mov	ah,1ah
	int	21h
	mov	bx,cs:[wrap_prevpsp]
	mov	ah,50h
	int	21h
						; remove break state
	mov	ax,3301h
	mov	dl,cs:[wrap_prevbreak]
	int	21h
	cli
						; restore sda
	movseg	ds,cs
	mov	cx,[wrap_sdasize]
	les	di,[sda_top]
	mov	si,ofs private_sda
	rep	movsw
	popm	<es,ds,di,si,dx,cx,bx,ax>
						; has error in int21?
	cmp	word ptr cs:[wrap_status],WRAP21_ERROR
	je	wrap21_err_in
						; return normally...
	popf
	mov	sp,word ptr cs:[wrap_prevstack]
	mov	ss,word ptr cs:[wrap_prevstack+2]
	mov	byte ptr cs:[wrap_injob],0
	sti
	ret
						; error in int21
wrap21_err_in:
	popf
	mov	sp,word ptr cs:[wrap_prevstack]
	mov	ss,word ptr cs:[wrap_prevstack+2]
	mov	byte ptr cs:[wrap_injob],0
	jmps	wrap21_err_exit
	
wrap21_err:
	mov	cs:[wrap_status],ax
wrap21_err_exit:
	mov	ax,-1
	sti
	stc
	ret
Wrap21		ENDP

		ENDIF				; ifdef BUILD_MINIMUM

COMMENT #
---------------------------------------
  int 23h (DOS Ctrl-C Exit)
  int 24h (DOS Critical Error handler)
---------------------------------------
#
		IFNDEF	BUILD_MINIMUM

PrivateHandler	PROC	FAR
PrivateInt24h	LABEL	FAR
	mov	word ptr cs:[wrap_status],WRAP21_ERROR
	mov	cs:[wrap_errorcode],di
	mov	al,0
PrivateInt23h	LABEL	FAR
	iret
PrivateHandler	ENDP

		ENDIF				; ifndef BUILD_MINIMUM

COMMENT #
---------------------------------------
  device driver stub
---------------------------------------
#

Strategy	PROC	FAR
	mov	word ptr cs:[reqhdr],bx
	mov	word ptr cs:[reqhdr+2],es
	ret
Strategy	ENDP

Commands	PROC	FAR
	pushm	<bx,ds>
	lds	bx,dword ptr cs:[reqhdr]
	mov	word ptr [bx+3],8103h
	popm	<ds,bx>
	ret
Commands	ENDP




;---------------------------------------
; Data (that would be instanced)
;
;
		EVEN

Instanced_top	LABEL	NEAR

reqhdr		dd	?
wrap_status	dw	0
wrap_errorcode	dw	0


		IFNDEF	BUILD_MINIMUM
		
wrap_prev23	dd	?
wrap_prev24	dd	?
wrap_prevstack	dd	?
wrap_prevdta	dd	?
wrap_prevpsp	dw	?


wrap_sdasize	dw	?
wrap_injob	db	0
wrap_prevbreak	db	0

		ENDIF			; BUILD_MINIMUM

KKCreg		LABEL	KKCstat
max_kkc		dw	MAX_NUM_KKC	; maxinum number of KKC
num_kkc		dw	0		; current number of KKC
cur_kkc		dw	-1		; current index value of acvite KKC
		KKCstat MAX_NUM_KKC dup (<>)
		
	Dev_bottom_minimum	LABEL	NEAR


		IFDEF	BUILD_MINIMUM
Dev_bottom	LABEL	NEAR
		ELSE
		EVEN
private_sda	LABEL	NEAR
		ENDIF
;---------------------------------------
;

InitCode_top	LABEL	NEAR


Pmsg		PROC	NEAR
	push	ax
	mov	ah,9
	int	21h
	pop	ax
	ret
Pmsg		ENDP

Pchar		PROC	NEAR
	pushm	<ax,dx>
	mov	dl,al
	mov	ah,2
	int	21h
	popm	<dx,ax>
	ret
Pchar		ENDP

PutOpening	PROC
	mov	dx,ofs msgLPKKC
	call	Pmsg
	mov	al,byte ptr [Dev_ID + 5]
	call	Pchar
	mov	al,'.'
	call	Pchar
	mov	al,byte ptr [Dev_ID + 6]
	call	Pchar
	mov	al,byte ptr [Dev_ID + 7]
	call	Pchar
	mov	dx,ofs msgCRLF
	call	Pmsg
	mov	dx,ofs msgCopyright
	call	Pmsg
	ret
PutOpening	ENDP

Init_Commands	PROC	FAR
	pushf
	pushm	<ax,bx,cx,dx,si,di,ds,es>
	lds	bx,dword ptr cs:[reqhdr]
	mov	word ptr [bx+3],810Ch
	mov	byte ptr [bx+13],1
	mov	word ptr [bx+14],0
	mov	word ptr [bx+16],cs
	movseg	ds,cs
	call	PutOpening
	
	IFDEF	USE_WINDOWS
	mov	word ptr [StartInfo.si_sinst], ofs inst_kkc
	mov	word ptr [StartInfo.si_sinst + 2], cs
	mov	word ptr [inst_kkc.sinst_ptr], ofs Instanced_top
	mov	word ptr [inst_kkc.sinst_ptr + 2], cs
	ENDIF
	
	IFNDEF	BUILD_MINIMUM
	mov	ax,5d06h		; Get SDA
	int	21h
	mov	word ptr cs:[sda_top],si
	mov	word ptr cs:[sda_top + 2],ds
	movseg	ds,cs
	inc	cx
	shr	cx,1
	mov	[sda_indos],cx
	inc	dx
	shr	dx,1
	mov	[sda_size],dx
	mov	ah,34h			; Get InDOS flag
	int	21h
	mov	word ptr [indos],bx
	mov	word ptr [indos+2],es
	ENDIF				; ifndef BUILD_MINIMUM
	
	mov	ax,352fh
	int	21h
	mov	word ptr [Org2F],bx
	mov	word ptr [Org2F+2],es
	;
	xor	bx,bx
	mov	ax,3306h			; Query true DOS ver (DOS5+)
	int	21h
	xchg	bh,bl
	cmp	bx,0500h
	jae	init_commands_2
	mov	dx,ofs errDosBelow5
init_commands_err:
	call	Pmsg
	jmp	init_commands_exit
init_commands_2:
	mov	ax,4d03h
	int	2fh
	mov	dx,ofs errAlreadyKKC
	cmp	ax,0
	je	init_commands_err
init_commands_resident:
	IFNDEF	BUILD_MINIMUM
	mov	ax,[sda_indos]
	add	ax,ax
	add	ax,ofs private_sda + 15
	and	ax,0fff0h		; private psp address
	push	ax
	add	ax,256
	add	ax,WRAP21_STACK		; bottom address of private stack
	mov	word ptr [private_stack],ax
	mov	word ptr [private_stack+2],cs
	ELSE
	mov	ax,ofs Dev_bottom_minimum
	ENDIF				; ifndef BUILD_MINIMUM
	
	les	bx,cs:[reqhdr]
	mov	word ptr es:[bx+14],ax	; and device.
	mov	word ptr es:[bx+3],0100h
	
	IFDEF	USE_WINDOWS
	sub	ax,ofs Instanced_top
	mov	[inst_kkc.sinst_size],ax
	ENDIF				; ifdef USE_WINDOWS
	
	IFNDEF	BUILD_MINIMUM
	pop	ax
	mov	dx,cs
	shr	ax,1
	shr	ax,1
	shr	ax,1
	shr	ax,1
	add	dx,ax			; private psp ID
	mov	[private_psp],dx
					; build private psp
	push	ds
	mov	es,[private_psp]
	xor	di,di
	xor	si,si
	mov	ah,62h
	int	21h
	mov	ds,bx
	mov	cx,128
	rep	movsb
	pop	ds
	;mov	word ptr es:[0016h],0
	;mov	word ptr es:[0032h],20
	mov	word ptr es:[0034h],0018h	; adjust JFT pointer
	mov	word ptr es:[0036h],es		; to private_psp:0018h
	
	ENDIF				; ifndef BUILD_MINIMUM
	
	mov	ax,252fh
	mov	dx,ofs New2F
	int	21h
	mov	cs:[Dev_commands],ofs Commands
init_commands_exit:
	popm	<es,ds,di,si,dx,cx,bx,ax>
	popf
	ret
Init_Commands	ENDP



;
;--------------------------------------

msgLPKKC	db	'LPKKC : Kana-Kanji Converter supporter'
		IFDEF	BUILD_MINIMUM
		db	' (minimum)'
		ENDIF			; ifdef BUILD_MINIMUM
		IFDEF	USE_WINDOWS
		db	' (for Windows)'
		ENDIF			; ifdef USE_WINDOWS
		db	'  ver $'
msgCRLF		db	CR,LF,'$'
msgCopyright	db	'(c)sava/LP-Project. 1997-2009',CR,LF,'$'
errDosBelow5	db	'You should have better to use DOS 5.0 or later...'
		db	CR,LF,'$'

errAlreadyKKC	db	'LPKKC.SYS (or KKCFUNC.SYS) already installed.'
		db	CR,LF,'$'


InitCode_bottom	LABEL	NEAR


		IFNDEF	BUILD_MINIMUM
		
		db	(MAX_PRIVATE_SDA + 256 + WRAP21_STACK) - (InitCode_bottom - private_sda) dup (?)
		
;private_sda	db	MAX_PRIVATE_SDA dup (?)
;
;		db	256 dup (0)		; private PSP & DTA
;		db	WRAP21_STACK dup (?)	; private stack

Dev_bottom	LABEL	NEAR
		ENDIF




_TEXT		ENDS


	END
